'\" $Id: comm.n,v 1.8 1996/12/15 20:36:56 loverso Exp loverso $
'\" %%_OSF_COPYRIGHT_%%
'\"
'	# DS - begin an indented unfilled display
.de DS
.RS
.nf
.sp
..
'	# DE - end of indented unfilled display
.de DE
.fi
.RE
.sp .5
..
'\"     # CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
'\"     # CE - end code excerpt
.de CE
.fi
.RE
..
'\"
'\"
.TH comm n 2.3 Comm "package Comm 2.3"
.SH NAME
comm.tcl \- A remote communications facility for Tcl 7.5 and later
.SH SYNOPSIS
\fBpackage require Comm 2.3\fR
.sp
'\"
'\" define all interfaces ONCE
'\"
.de i1
\\fB\\$1 send \\fR?\\fI-async\\fR? \\fIid cmd \\fR?\\fIarg arg ...\\fR?
..
.de i2
\\fB\\$1 interps\\fR
..
.de i3
\\fB\\$1 self\\fR
..
.de i4
\\fB\\$1 connect \\fR?\\fIid\\fR?
..
.de i5
\\fB\\$1 new \\fIchan\\fR ?\\fB-port \fIport\fR ?-\\fBlocal \fI0|1\fR?
..
.de i6
\\fB\\$1 init \\fIchan\\fR ?\\fB-port \fIport\fR ?-\\fBlocal \fI0|1\fR?
..
.de i7
\\fB\\$1 channels\\fR
..
.de i8
\\fB\\$1 shutdown \\fIid\\fR
..
.de i9
\\fB\\$1 abort\\fR
..
.de iA
\\fB\\$1 destroy\\fR
..
.de iB
\\fB\\$1 remoteid\\fR
..
.de iC
\\fB\\$1 hook \\fIevent\\fR ?\\fB+\\fR??\\fIscript\\fR?
..
'\"
'\" Show all interfaces
'\"
.i1 \fIchan\fP
.sp
.i2 \fIchan\fP
.sp
.i3 \fIchan\fP
.sp
.i4 \fIchan\fP
.sp
.i5 \fIchan\fP
.sp
.i6 \fIchan\fP
.sp
.i7 \fIchan\fP
.sp
.i8 \fIchan\fP
.sp
.i9 \fIchan\fP
.sp
.iA \fIchan\fP
.sp
.iB \fIchan\fP
.sp
.iC \fIchan\fP
.sp
The package initializes \fBcomm\fR as the default \fIchan\fR.
'\"
'\"
'\"
.SH "INTRODUCTION"
.PP
.fi
The
.B comm
command provides an inter-interpreter remote execution facility
much like Tk's
.IR send "(n)",
except that it uses sockets rather than
the X server for the communication path.
As a result,
.B comm
works with multiple interpreters,
works on Windows and Macintosh systems,
and
provides more control over the remote execution path.
.LP
These commands work just like
.B send
and
.BR "winfo interps" :
.CS
.i1 \fBcomm\fP
.i2 \fBcomm\fP
.CE
This is all that is really needed to know in order to use
.BR comm .
'\"
'\"
'\"
.SH DESCRIPTION
.PP
.B comm
names communication endpoints with an
.I id
unique to each machine.
Before sending commands, the
.I id
of another interpreter is needed.
Unlike Tk's send,
.B comm
doesn't implicitly know the
.IR id 's
of all the interpreters on the system.
.TP
.i1 \fBcomm\fP
This invokes the given command in the interpreter named by
.IR id .
The command waits for the result and remote errors are returned
unless the
.B -async
option is given.
.TP
.i3 \fBcomm\fP
Returns the
.I id
for this channel.
.TP
.i2 \fBcomm\fP
Returns a list of all the remote
.IR id 's
to which this channel is connected.
.B comm
learns a new remote
.I id
when a command is first issued it,
or when a remote
.I id
first issues a command to this comm channel.
.TP
.i4 \fBcomm\fP
Whereas
.B "comm send"
will automatically connect to the given
.IR id ,
this forces a connection to a remote
.I id
without sending a command.
After this, the remote
.I id
will appear in
.BR "comm interps" .
.LP
These four methods make up the basic
.B comm
interface.
'\"
'\"
'\"
.SH "SEMANTICS"
.PP
The semantics of
.B "comm send"
are intended to match Tk's
.B send
.IR exactly .
If you find that
.B "comm send"
doesn't work for a particular command,
try the same thing with Tk's send and see if the result is different.
If so, let me know.
.LP
For instance, I had one report that this command produced an error.
Note that the equivalent command produces the same error.
.CS
% \fBcomm send \fIid\fP llength {a b c}\fR
\fBwrong # args: should be "llength list"\fR
% \fBsend \fIname\fP llength {a b c}\fR
\fBwrong # args: should be "llength list"\fR
.CE
'\"
'\"
'\"
.SH "MULTIPLE LISTENERS"
.PP
More than one
.B comm
channel (or
.IR listener )
can be created in each Tcl interpeter.
This allows flexibility to create full and restricted channels.
.TP
.i5 \fBcomm\fP
This creates a new channel and Tcl command with the given channel name.
This new command controls the channel, and takes all the same
arguments as
.BR comm .
.TP
.i7 \fBcomm\fP
This lists all the channels allocated in this interpreter.
.TP
.i6 \fBcomm\fP
This allows changes in the parameters of an existing channel.
Note that it does this by closing and reopening the socket.
Hence, the channel's
.I id
will change when it is used.
'\"
'\"
'\"
.SH "ID/PORT ASSIGNMENTS"
.PP
Note that it is possible to place a
.B comm
channel in a slave interpreter,
thus providing a protected remote evaluation environment.
.LP
.B comm
uses a TCP port for endpoint
.IR id .
The
.B interps
method merely lists all the TCP ports to which the channel is connected.
By default, each channel's
.I id
is a high-numbered TCP port (>10000) which
.B comm
listens on for connections.
Alternately, a specific TCP port number may be provided for a given channel.
Using a value of 0 requests that the OS pick a low-numbered (>1024) TCP port.
Note that a channel won't be created and initialized
unless the specific port can be allocated.
'\"
'\"
'\"
.SH "REMOTE INTERPRETERS"
.PP
By default, each channel is restricted to accepting connections from the
local system.  This can be overriden by using the
.B "-local 0"
option to
.B "comm new"
or
.BR "comm init" .
For such channels, the
.I id
parameter takes the form
.BI { "id host" }
.BR "" .
.LP
.BR WARNING :
The
.I host
must always be specified in the same form
(e.g., as either a fully qualified domain name,
plain hostname or an IP address).
'\"
'\"
'\"
.SH "CLOSING CONNECTIONS"
.PP
These methods give control over closing connections:
.TP
.i8 \fBcomm\fP
This closes the connection to
.IR id ,
aborting all outstanding commands in progress.  Note that nothing
prevents the connection from being immediately reopened by another
incoming or outgoing command.
.TP
.i9 \fBcomm\fP
This invokes shutdown on all open connections in this comm channel.
.TP
.iA \fBcomm\fP
This aborts all connections and then destroys the this comm channel itself,
including closing the listening socket.
Special code allows the default
.B comm
channel to be closed
such that the
.B comm
command it is not destroyed.
Doing so closes the listening socket, preventing both
incoming and outgoing commands on the channel.
This sequence reinitializes the default channel:
.CS
.B "comm destroy; comm new comm"
.CE
'\"
'\"
'\"
.SH "Dead Peer Detection:
.PP
When a remote connection is lost,
.B comm
can invoke an application callback.
This can be used to cleanup or restart an ancillary process,
for instance.
See the
.B lost
callback below.
'\"
'\"
'\"
.SH CALLBACKS
.PP
This is a mechanism for setting hooks for particular events:
.CS
.iC \fBcomm\fP
.CE
.sp
.BR NOTE :
those listed as
.B UNIMPLEMENTED
are unimplemented at this time.
.LP
When an
.I event
occurs,
.I script
is evaluated with the listed variables in scope and available.
.LP
In a syntax similar to Tk's
.B bind
command, prefixing
.I script
with a + causes the new script to be appended.
Without this, a new
.I script
will replace the an existing one.
When invoked without a script, no change is made.
In all cases, the new hook script is returned by the command.
.LP
Common variables include:
.DS
.IP \fBchan\fR 5
the name of the comm channel (and command)
.IP \fBid\fR 5
the id of the remote in question
.IP \fBfid\fR 5
the file id for the socket of the connection
.DE
.ta 4i
.de Hk
.TP
.B \\$1	\\$3
Variables:
.I "\\$2"
.br
..
.LP
These are the defined
.IR events :
.\"
.Hk connecting "chan id" UNIMPLEMENTED
Hook invoked before making a remote connection.
Use
.B return
to allow the connection, or
.B error
to abort the connection attempt with an error.
.\"
.Hk connected "chan id fid" UNIMPLEMENTED
Hook invoked after making a remote connection,
allowing arbitrary authentication over the socket.
Use
.B return
to allow the connection, or
.B error
to close the connection with an error.
.\"
.Hk incoming "chan id fid remport addr" UNIMPLEMENTED
Hook invoked when receiving an incoming connection,
allowing arbitrary authentication over fid.
Use
.B return
to allow the connection, or
.B error
to close the connection with an error.
.\"
.Hk eval "chan id cmd done" UNIMPLEMENTED
Hook invoked after collecting a complete command from the remote
but before evalutating it.
Use
.B return
to allow the command to be executed.
Use
.B "return -code break"
to indicate that the command has been 
Use
.B error
to indicate that the command was refused.
Set
.I done
to 1 to indicate that the command has been executed and
give the return value with
.BR return " or " error .
.\"
.Hk lost "chan id reason"
Hook invoked when connection to
.I id
was lost.
Return value is ignored.
.I reason
is an explanatory string indicating why the connection was lost.
Sample use:
.sp
.CS
comm hook lost {
    global myvar
    if {$myvar(id) == $id} {
        myfunc
        return
    }
}
.CE
'\"
'\"
'\"
.SH UNSUPPORTED
.PP
These interfaces may change or go away in subsequence releases.
.TP
.iB \fBcomm\fP
Returns the
.I id
of the last remote command executed on the channel.
If used by a proc being invoked remotely, it
must be called before any events are processed.
Otherwise, another command may get invoked and change
the value.
.LP
Invoking the procedure
.B "comm_send"
will substitute
.B send
and
.B "winfo interps"
commands with these equivalents that use
.BR comm .
.sp
.CS
proc send {args} {
    eval comm send $args
}
rename winfo tk_winfo
proc winfo {cmd args} {
    if ![string match in* $cmd] {return [eval [list tk_winfo $cmd] $args]}
    return [comm interps]
}
.CE
'\"
'\"
'\"
.SH SECURITY
.PP
Something here soon.
'\"
'\"
'\"
.SH COMPATIBILITY
.PP
The major version of 
.B comm
describes the overall compatibility of the API and protocol.  Currently,
this is at 2.
.LP
The minor version will change when minor API changes happen.  Recent
changes, other than bug fixes, include:
.IP "2.3" 5
.B "comm ids"
was renamed to
.B "comm channels".
General support for
.B "comm hook"
was fully implemented, but
only the
.B lost
hook exists, and it was changed to follow the general hook API.
.B commLostHook
and
.B commLost
were removed.
.IP "2.2" 5
The 
.B died
hook was renamed
.BR lost ,
to be accessed by
.B commLostHook
and an early implementation of
.BR "comm lost hook" .
As such,
.B commDied
is now
.BR commLost .
.IP "2.1" 5
Unsupported method
.B "comm remoteid"
was added.
.IP "2.0" 5
.B comm
was rewritten from scratch.
'\"
'\"
'\"
.SH "SEE ALSO"
.IR send "(n)"
.SH AUTHOR
John@LoVerso.Southborough.MA.US
.SH COPYRIGHT
%%_OSF_COPYRIGHT_%%
'\"
'\"
'\"
.SH BUGS
.PP
These are mostly outstanding todo items.  Most are
easily done with existing hooks, but I want to make them easier:
.IP \(bu 2
Implement documented hooks.
.IP \(bu 2
Allow use of a slave interp for actual command execution
(especially when operating in "not local" mode).
.IP \(bu
Add host list (xhost-like) or "magic cookie" (xauth-like)
authentication to initial handshake.
.IP \(bu
Add an interp discovery and name->port mapping.
(likely to be in a separate, optional nameserver).
.IP \(bu
Fix the
.I "{id host}"
form so as not to be dependent upon canonical hostnames.
This requires fixes to Tcl to resolve hostnames!
.IP \(bu
Complete the
.IR shutdown ", " abort ", and " destroy
methods.
In particular, they may do bad things when you are connected to yourself.
.LP
.sp 2
This man page is bigger than the source file.
'\"
'\"
'\"
.SH WARNINGS
.PP
Tcl7.5 under Windows contains a bug that causes the interpreter to
hang when EOF is reached on non-blocking sockets.  This can be
triggered with a command such as this:
.CS
.B "comm send $other exit"
.CE
Always make sure the channel is quiescent before closing/exiting.
It is recommended you use at least Tcl7.6 under Windows.
.LP
Tcl7.6 on the Mac contains several bugs.  It is recommended you use
at least Tcl7.6p1.
'\"
'\"
'\"
